//
// compare.js をなるべく少ない文字数で書き直してください♪
// このファイル（main.js）でエラーが出なければ（テストに合格すれば）OK です♪
// このファイル（main.js）は変更しないでください♪
//
import compare from './compare.js';

const load = async (src) => {
  const img = new Image();

  img.src = src;
  await img.decode();

  return img;
};

// width と height は実戦では（表示用に）書き換えられている可能性があるため
// その状況をシミュレートするために適当な値で書き換えています♪
// 画像の幅と高さを知るには、width と height ではなく
// （読み取り専用の）naturalWidth と naturalHeight を使用してください♪
// （※ naturalWidth と naturalHeight も厳密には画像本来の幅と高さであるとは限りませんが本問題では考慮不要とします）
// （※【参考】https://developer.mozilla.org/ja/docs/Web/API/HTMLImageElement/naturalWidth）
const overrideDimensions = (img) => {
  img.width = img.height = 1;

  return img;
};

const a = overrideDimensions(await load('img/a.png'));
const b = overrideDimensions(await load('img/b.png'));
const c = overrideDimensions(await load('img/c.png'));
const d = overrideDimensions(await load('img/d.png'));
const e = overrideDimensions(await load('img/e.png'));
const f = overrideDimensions(await load('img/f.png'));
const g = overrideDimensions(await load('img/g.png'));
const h = overrideDimensions(await load('img/h.png'));
const i = overrideDimensions(await load('img/i.png'));
const j = overrideDimensions(await load('img/j.png'));
const k = overrideDimensions(await load('img/k.png'));
const l = overrideDimensions(await load('img/l.png'));
const m = overrideDimensions(await load('img/m.png'));
const n = overrideDimensions(await load('img/n.png'));
const o = overrideDimensions(await load('img/o.png'));
const p = overrideDimensions(await load('img/p.png'));

console.assert(compare(a, b) < 0, 'b は a より横長です');
console.assert(compare(b, c) < 0, 'c は b より横長です');
console.assert(compare(c, d) < 0, 'd は c より横長です');
console.assert(compare(d, e) > 0, 'd は e より横長です');
console.assert(compare(e, f) > 0, 'e は f より横長です');
console.assert(compare(f, g) > 0, 'f は g より横長です');
console.assert(compare(g, h) < 0, 'h は g より横長です');
console.assert(compare(h, i) > 0, 'h は i より横長です');
console.assert(compare(i, j) > 0, 'i は j より横長です');
console.assert(compare(j, k) > 0, 'j は k より横長です');
console.assert(compare(k, l) < 0, 'l は k より横長です');
console.assert(compare(l, m) < 0, 'm は l より横長です');
console.assert(compare(m, n) > 0, 'm は n より横長です');
console.assert(compare(n, o) < 0, 'o は n より横長です');
console.assert(compare(o, p) === 0, 'o は p より横長でも縦長でもありません');

const { length } = await fetch('compare.js')
  .then((res) => res.text())
  .then((str) => str.trim());

console.log(
  `%cJS体操 No. 2\n%c${length}%c文字\n%cpowered by 面白法人カヤック`,
  'font-weight:bold;font-size:200%;',
  'font-weight:bold;font-size:800%;color:#0af;',
  'font-size:100%;',
  'font-weight:bold;font-size:100%;color:#fc6;',
);
